## Alpha API Report File for "@fluidframework/container-definitions"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

// @public
export enum AttachState {
    Attached = "Attached",
    Attaching = "Attaching",
    Detached = "Detached"
}

// @public
export namespace ConnectionState {
    export type CatchingUp = 1;
    export type Connected = 2;
    export type Disconnected = 0;
    export type EstablishingConnection = 3;
}

// @public
export type ConnectionState = ConnectionState.Disconnected | ConnectionState.EstablishingConnection | ConnectionState.CatchingUp | ConnectionState.Connected;

// @alpha @legacy
export const ContainerErrorTypes: {
    readonly clientSessionExpiredError: "clientSessionExpiredError";
    readonly genericError: "genericError";
    readonly throttlingError: "throttlingError";
    readonly dataCorruptionError: "dataCorruptionError";
    readonly dataProcessingError: "dataProcessingError";
    readonly usageError: "usageError";
};

// @alpha @legacy
export type ContainerErrorTypes = (typeof ContainerErrorTypes)[keyof typeof ContainerErrorTypes];

// @alpha @legacy
export interface ContainerWarning extends IErrorBase_2 {
    logged?: boolean;
}

// @public
export interface IAudience extends IEventProvider<IAudienceEvents> {
    getMember(clientId: string): IClient | undefined;
    getMembers(): Map<string, IClient>;
    getSelf(): ISelf | undefined;
}

// @public
export interface IAudienceEvents extends IEvent {
    // @eventProperty
    (event: "addMember", listener: (clientId: string, client: IClient) => void): void;
    // @eventProperty
    (event: "removeMember", listener: (clientId: string, client: IClient) => void): void;
    (event: "selfChanged", listener: (oldValue: ISelf | undefined, newValue: ISelf) => void): void;
}

// @alpha @legacy
export interface IAudienceOwner extends IAudience {
    addMember(clientId: string, details: IClient): void;
    removeMember(clientId: string): boolean;
    setCurrentClientId(clientId: string): void;
}

// @alpha @legacy
export interface IBatchMessage {
    // (undocumented)
    compression?: string;
    // (undocumented)
    contents?: string;
    // (undocumented)
    metadata?: Record<string, unknown>;
    // (undocumented)
    referenceSequenceNumber?: number;
}

// @alpha @legacy
export interface ICodeDetailsLoader extends Partial<IProvideFluidCodeDetailsComparer> {
    load(source: IFluidCodeDetails): Promise<IFluidModuleWithDetails>;
}

// @alpha @legacy
export interface IConnectionDetails {
    checkpointSequenceNumber: number | undefined;
    // (undocumented)
    claims: ITokenClaims;
    clientId: string;
    // (undocumented)
    serviceConfiguration: IClientConfiguration;
}

// @alpha @legacy
export interface IContainer extends IEventProvider<IContainerEvents> {
    attach(request: IRequest, attachProps?: {
        deltaConnection?: "none" | "delayed";
    }): Promise<void>;
    readonly attachState: AttachState;
    readonly audience: IAudience;
    readonly clientId?: string | undefined;
    close(error?: ICriticalContainerError): void;
    readonly closed: boolean;
    connect(): void;
    readonly connectionState: ConnectionState;
    containerMetadata: Record<string, string>;
    deltaManager: IDeltaManager<ISequencedDocumentMessage, IDocumentMessage>;
    disconnect(): void;
    dispose(error?: ICriticalContainerError): void;
    readonly disposed?: boolean;
    forceReadonly?(readonly: boolean): any;
    getAbsoluteUrl(relativeUrl: string): Promise<string | undefined>;
    getEntryPoint(): Promise<FluidObject>;
    getLoadedCodeDetails(): IFluidCodeDetails | undefined;
    getQuorum(): IQuorumClients;
    getSpecifiedCodeDetails(): IFluidCodeDetails | undefined;
    readonly isDirty: boolean;
    proposeCodeDetails(codeDetails: IFluidCodeDetails): Promise<boolean>;
    readonly readOnlyInfo: ReadOnlyInfo;
    resolvedUrl: IResolvedUrl | undefined;
    serialize(): string;
}

// @alpha @legacy
export interface IContainerContext {
    readonly attachState: AttachState;
    // (undocumented)
    readonly audience: IAudience;
    // (undocumented)
    readonly baseSnapshot: ISnapshotTree | undefined;
    // (undocumented)
    readonly clientDetails: IClientDetails;
    // (undocumented)
    readonly clientId: string | undefined;
    // (undocumented)
    readonly closeFn: (error?: ICriticalContainerError) => void;
    // (undocumented)
    readonly connected: boolean;
    // (undocumented)
    readonly deltaManager: IDeltaManager<ISequencedDocumentMessage, IDocumentMessage>;
    // (undocumented)
    readonly disposeFn?: (error?: ICriticalContainerError) => void;
    getAbsoluteUrl?(relativeUrl: string): Promise<string | undefined>;
    // (undocumented)
    getLoadedFromVersion(): IVersion | undefined;
    // @deprecated
    readonly id: string;
    // (undocumented)
    readonly loader: ILoader;
    readonly options: Record<string | number, any>;
    // (undocumented)
    pendingLocalState?: unknown;
    // (undocumented)
    readonly quorum: IQuorumClients;
    readonly scope: FluidObject;
    readonly snapshotWithContents?: ISnapshot;
    // (undocumented)
    readonly storage: IDocumentStorageService;
    // (undocumented)
    readonly submitBatchFn: (batch: IBatchMessage[], referenceSequenceNumber?: number) => number;
    // @deprecated (undocumented)
    readonly submitFn: (type: MessageType, contents: any, batch: boolean, appData?: any) => number;
    // (undocumented)
    readonly submitSignalFn: (contents: unknown, targetClientId?: string) => void;
    // (undocumented)
    readonly submitSummaryFn: (summaryOp: ISummaryContent, referenceSequenceNumber?: number) => number;
    // @deprecated (undocumented)
    readonly supportedFeatures?: ReadonlyMap<string, unknown>;
    // (undocumented)
    readonly taggedLogger: ITelemetryBaseLogger;
    // (undocumented)
    updateDirtyContainerState(dirty: boolean): void;
}

// @alpha @legacy
export interface IContainerEvents extends IEvent {
    (event: "readonly", listener: (readonly: boolean) => void): void;
    (event: "connected", listener: (clientId: string) => void): any;
    (event: "codeDetailsProposed", listener: (codeDetails: IFluidCodeDetails, proposal: ISequencedProposal) => void): any;
    (event: "disconnected", listener: () => void): any;
    (event: "attaching", listener: () => void): any;
    (event: "attached", listener: () => void): any;
    (event: "closed", listener: (error?: ICriticalContainerError) => void): any;
    (event: "disposed", listener: (error?: ICriticalContainerError) => void): any;
    (event: "warning", listener: (error: ContainerWarning) => void): any;
    (event: "op", listener: (message: ISequencedDocumentMessage) => void): any;
    (event: "dirty", listener: (dirty: boolean) => void): any;
    (event: "saved", listener: (dirty: boolean) => void): any;
    (event: "metadataUpdate", listener: (metadata: Record<string, string>) => void): any;
}

// @alpha @legacy (undocumented)
export interface IContainerLoadMode {
    // (undocumented)
    deltaConnection?: "none" | "delayed" | undefined;
    // (undocumented)
    opsBeforeReturn?: undefined | "cached" | "all";
}

// @alpha @legacy
export type IContainerPolicies = {
    maxClientLeaveWaitTime?: number;
};

// @public
export type ICriticalContainerError = IErrorBase_2;

// @alpha @sealed @legacy
export interface IDeltaManager<T, U> extends IEventProvider<IDeltaManagerEvents>, IDeltaSender {
    readonly active: boolean;
    readonly clientDetails: IClientDetails;
    readonly hasCheckpointSequenceNumber: boolean;
    readonly inboundSignal: IDeltaQueue<ISignalMessage>;
    readonly initialSequenceNumber: number;
    readonly lastKnownSeqNumber: number;
    readonly lastMessage: ISequencedDocumentMessage | undefined;
    readonly lastSequenceNumber: number;
    readonly maxMessageSize: number;
    readonly minimumSequenceNumber: number;
    // (undocumented)
    readonly readOnlyInfo: ReadOnlyInfo;
    readonly serviceConfiguration: IClientConfiguration | undefined;
    submitSignal(content: any, targetClientId?: string): void;
    readonly version: string;
}

// @alpha @sealed @legacy
export interface IDeltaManagerEvents extends IEvent {
    // @deprecated (undocumented)
    (event: "prepareSend", listener: (messageBuffer: any[]) => void): any;
    // @deprecated (undocumented)
    (event: "submitOp", listener: (message: IDocumentMessage) => void): any;
    (event: "op", listener: (message: ISequencedDocumentMessage, processingTime: number) => void): any;
    (event: "pong", listener: (latency: number) => void): any;
    (event: "connect", listener: (details: IConnectionDetails, opsBehind?: number) => void): any;
    (event: "disconnect", listener: (reason: string, error?: IAnyDriverError) => void): any;
    (event: "readonly", listener: (readonly: boolean, readonlyConnectionReason?: {
        reason: string;
        error?: IErrorBase_2;
    }) => void): any;
}

// @alpha @sealed @legacy
export interface IDeltaQueue<T> extends IEventProvider<IDeltaQueueEvents<T>>, IDisposable {
    idle: boolean;
    length: number;
    pause(): Promise<void>;
    paused: boolean;
    peek(): T | undefined;
    resume(): void;
    toArray(): T[];
    waitTillProcessingDone(): Promise<{
        count: number;
        duration: number;
    }>;
}

// @alpha @sealed @legacy
export interface IDeltaQueueEvents<T> extends IErrorEvent {
    (event: "push", listener: (task: T) => void): any;
    (event: "op", listener: (task: T) => void): any;
    (event: "idle", listener: (count: number, duration: number) => void): any;
}

// @alpha @sealed @legacy
export interface IDeltaSender {
    flush(): void;
}

export { IErrorBase }

// @alpha @legacy
export interface IFluidBrowserPackage extends IFluidPackage {
    fluid: {
        browser: IFluidBrowserPackageEnvironment;
        [environment: string]: IFluidPackageEnvironment;
    };
}

// @alpha @legacy
export interface IFluidBrowserPackageEnvironment extends IFluidPackageEnvironment {
    umd: {
        files: string[];
        library: string;
    };
}

// @alpha @legacy
export interface IFluidCodeDetails {
    readonly config?: IFluidCodeDetailsConfig;
    readonly package: string | Readonly<IFluidPackage>;
}

// @alpha @legacy (undocumented)
export const IFluidCodeDetailsComparer: keyof IProvideFluidCodeDetailsComparer;

// @alpha @legacy
export interface IFluidCodeDetailsComparer extends IProvideFluidCodeDetailsComparer {
    compare(a: IFluidCodeDetails, b: IFluidCodeDetails): Promise<number | undefined>;
    satisfies(candidate: IFluidCodeDetails, constraint: IFluidCodeDetails): Promise<boolean>;
}

// @alpha @legacy
export interface IFluidCodeDetailsConfig {
    // (undocumented)
    readonly [key: string]: string;
}

// @alpha @legacy (undocumented)
export interface IFluidModule {
    // (undocumented)
    fluidExport: FluidObject<IRuntimeFactory & IProvideFluidCodeDetailsComparer>;
}

// @alpha @legacy
export interface IFluidModuleWithDetails {
    details: IFluidCodeDetails;
    module: IFluidModule;
}

// @alpha @legacy
export interface IFluidPackage {
    [key: string]: unknown;
    fluid: {
        [environment: string]: undefined | IFluidPackageEnvironment;
    };
    name: string;
}

// @alpha @legacy
export interface IFluidPackageEnvironment {
    [target: string]: undefined | {
        files: string[];
        [key: string]: unknown;
    };
}

// @alpha @legacy
export interface IGetPendingLocalStateProps {
    readonly notifyImminentClosure: boolean;
    readonly sessionExpiryTimerStarted?: number;
    readonly snapshotSequenceNumber?: number;
    readonly stopBlobAttachingSignal?: AbortSignal;
}

// @alpha @legacy
export interface IHostLoader extends ILoader {
    createDetachedContainer(codeDetails: IFluidCodeDetails, createDetachedProps?: {
        canReconnect?: boolean;
        clientDetailsOverride?: IClientDetails;
    }): Promise<IContainer>;
    rehydrateDetachedContainerFromSnapshot(snapshot: string, createDetachedProps?: {
        canReconnect?: boolean;
        clientDetailsOverride?: IClientDetails;
    }): Promise<IContainer>;
}

// @alpha @legacy
export interface ILoader extends Partial<IProvideLoader> {
    resolve(request: IRequest, pendingLocalState?: string): Promise<IContainer>;
}

// @alpha @legacy
export type ILoaderOptions = {
    cache?: boolean;
    client?: IClient;
    enableOfflineLoad?: boolean;
    provideScopeLoader?: boolean;
    maxClientLeaveWaitTime?: number;
};

// @alpha @legacy (undocumented)
export interface IProvideFluidCodeDetailsComparer {
    // (undocumented)
    readonly IFluidCodeDetailsComparer: IFluidCodeDetailsComparer;
}

// @alpha @legacy (undocumented)
export interface IProvideLoader {
    // (undocumented)
    readonly ILoader: ILoader;
}

// @alpha @legacy (undocumented)
export interface IProvideRuntimeFactory {
    // (undocumented)
    readonly IRuntimeFactory: IRuntimeFactory;
}

// @alpha @legacy
export interface IRuntime extends IDisposable {
    createSummary(blobRedirectTable?: Map<string, string>): ISummaryTree;
    getEntryPoint(): Promise<FluidObject>;
    getPendingLocalState(props?: IGetPendingLocalStateProps): unknown;
    notifyOpReplay?(message: ISequencedDocumentMessage): Promise<void>;
    process(message: ISequencedDocumentMessage, local: boolean): any;
    processSignal(message: any, local: boolean): any;
    setAttachState(attachState: AttachState.Attaching | AttachState.Attached): void;
    setConnectionState(connected: boolean, clientId?: string): any;
}

// @alpha @legacy (undocumented)
export const IRuntimeFactory: keyof IProvideRuntimeFactory;

// @alpha @legacy
export interface IRuntimeFactory extends IProvideRuntimeFactory {
    instantiateRuntime(context: IContainerContext, existing: boolean): Promise<IRuntime>;
}

// @public
export interface ISelf {
    readonly client?: IClient;
    readonly clientId: string;
}

// @alpha @legacy
export const isFluidBrowserPackage: (maybePkg: unknown) => maybePkg is Readonly<IFluidBrowserPackage>;

// @alpha @legacy
export const isFluidPackage: (pkg: unknown) => pkg is Readonly<IFluidPackage>;

// @alpha @legacy
export interface ISnapshotTreeWithBlobContents extends ISnapshotTree {
    // (undocumented)
    blobsContents?: {
        [path: string]: ArrayBufferLike;
    };
    // (undocumented)
    trees: {
        [path: string]: ISnapshotTreeWithBlobContents;
    };
}

export { IThrottlingWarning }

// @alpha @legacy
export enum LoaderHeader {
    // @deprecated (undocumented)
    cache = "fluid-cache",
    // (undocumented)
    clientDetails = "fluid-client-details",
    loadMode = "loadMode",
    // (undocumented)
    reconnect = "fluid-reconnect",
    sequenceNumber = "fluid-sequence-number",
    version = "version"
}

// @alpha @legacy (undocumented)
export type ReadOnlyInfo = {
    readonly readonly: false | undefined;
} | {
    readonly readonly: true;
    readonly forced: boolean;
    readonly permissions: boolean | undefined;
    readonly storageOnly: boolean;
    readonly storageOnlyReason?: string;
};

```
