"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFluidBrowserPackage = void 0;
const fluidPackage_js_1 = require("./fluidPackage.js");
/**
 * Determines if any object is an IFluidBrowserPackage
 * @param maybePkg - The object to check for compatibility with IFluidBrowserPackage
 * @legacy
 * @alpha
 */
const isFluidBrowserPackage = (maybePkg) => (0, fluidPackage_js_1.isFluidPackage)(maybePkg) &&
    typeof maybePkg?.fluid?.browser?.umd?.library === "string" &&
    Array.isArray(maybePkg?.fluid?.browser?.umd?.files);
exports.isFluidBrowserPackage = isFluidBrowserPackage;
//# sourceMappingURL=browserPackage.js.map