"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.IFluidCodeDetailsComparer = exports.isFluidCodeDetails = exports.isFluidPackage = void 0;
/**
 * Check if the package.json defines a Fluid package
 * @param pkg - the package json data to check if it is a Fluid package.
 * @legacy
 * @alpha
 */
const isFluidPackage = (pkg) => typeof pkg === "object" &&
    typeof pkg?.name === "string" &&
    typeof pkg?.fluid === "object";
exports.isFluidPackage = isFluidPackage;
/**
 * Determines if any object is an IFluidCodeDetails
 * @internal
 */
const isFluidCodeDetails = (details) => {
    const maybeCodeDetails = details;
    return (typeof maybeCodeDetails === "object" &&
        (typeof maybeCodeDetails?.package === "string" ||
            (0, exports.isFluidPackage)(maybeCodeDetails?.package)) &&
        (maybeCodeDetails?.config === undefined || typeof maybeCodeDetails?.config === "object"));
};
exports.isFluidCodeDetails = isFluidCodeDetails;
/**
 * @legacy
 * @alpha
 */
exports.IFluidCodeDetailsComparer = "IFluidCodeDetailsComparer";
//# sourceMappingURL=fluidPackage.js.map