/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { isFluidPackage } from "./fluidPackage.js";
/**
 * Determines if any object is an IFluidBrowserPackage
 * @param maybePkg - The object to check for compatibility with IFluidBrowserPackage
 * @legacy
 * @alpha
 */
export const isFluidBrowserPackage = (maybePkg) => isFluidPackage(maybePkg) &&
    typeof maybePkg?.fluid?.browser?.umd?.library === "string" &&
    Array.isArray(maybePkg?.fluid?.browser?.umd?.files);
//# sourceMappingURL=browserPackage.js.map