/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { FluidErrorTypes } from "@fluidframework/core-interfaces/internal";
/**
 * Different error types the ClientSession may report out to the Host.
 * @legacy
 * @alpha
 */
export const ContainerErrorTypes = {
    ...FluidErrorTypes,
    /**
     * Error indicating an client session has expired. Currently this only happens when GC is allowed on a document and
     * aids in safely deleting unused objects.
     */
    clientSessionExpiredError: "clientSessionExpiredError",
};
//# sourceMappingURL=error.js.map