/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Check if the package.json defines a Fluid package
 * @param pkg - the package json data to check if it is a Fluid package.
 * @legacy
 * @alpha
 */
export const isFluidPackage = (pkg) => typeof pkg === "object" &&
    typeof pkg?.name === "string" &&
    typeof pkg?.fluid === "object";
/**
 * Determines if any object is an IFluidCodeDetails
 * @internal
 */
export const isFluidCodeDetails = (details) => {
    const maybeCodeDetails = details;
    return (typeof maybeCodeDetails === "object" &&
        (typeof maybeCodeDetails?.package === "string" ||
            isFluidPackage(maybeCodeDetails?.package)) &&
        (maybeCodeDetails?.config === undefined || typeof maybeCodeDetails?.config === "object"));
};
/**
 * @legacy
 * @alpha
 */
export const IFluidCodeDetailsComparer = "IFluidCodeDetailsComparer";
//# sourceMappingURL=fluidPackage.js.map