/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Accepted header keys for requests coming to the Loader
 * @legacy
 * @alpha
 */
export var LoaderHeader;
(function (LoaderHeader) {
    /**
     * @deprecated This header has been deprecated and will be removed in a future release
     * Override the Loader's default caching behavior for this container.
     */
    LoaderHeader["cache"] = "fluid-cache";
    LoaderHeader["clientDetails"] = "fluid-client-details";
    /**
     * Start the container in a paused, unconnected state. Defaults to false
     */
    LoaderHeader["loadMode"] = "loadMode";
    LoaderHeader["reconnect"] = "fluid-reconnect";
    /**
     * Loads the container to at least the specified sequence number.
     * If not defined, behavior will fall back to `IContainerLoadMode.opsBeforeReturn`.
     */
    LoaderHeader["sequenceNumber"] = "fluid-sequence-number";
    /**
     * One of the following:
     * null or "null": use ops, no snapshots
     * undefined: fetch latest snapshot
     * otherwise, version sha to load snapshot
     */
    LoaderHeader["version"] = "version";
})(LoaderHeader || (LoaderHeader = {}));
//# sourceMappingURL=loader.js.map